-----------------------------------------------------------------------------
--
-- 	Functions needed by the animate/select user interface
--
--	v1.0:	First version, merge of different files
--
-----------------------------------------------------------------------------

global SSR_gui

struct SSR_gui
(	
	-- Forward declarations
	function refreshSelectIcons = (),
	function listCharacters = (),
	function pickCTL = (),
	function boolSelCTL = (),
	function setSelection = (),
	
	function resetCharAttributes = (),
	function keyCharAttributes = (),
	function objAlign = (),
	function keyAll = (),
	function ikSwitch = (),
	function lockRoot = (),
	
	-----------------------------------------------------------------------------
	-- Updates character selector window icon visibility
	-- Thanks to Hvard Schei!
	-----------------------------------------------------------------------------
	function refreshSelectIcons charName window =
	(
		-- Turn off all buttons
		for i in window.controls where \
			classof i == buttonControl and matchPattern i.name pattern:"pick*" \
			do i.visible = false

		if charName != undefined then 
		(
			local controllers = execute ("$'" + charName + "_*_CTL")
			
			for c in controllers do 
			(
				-- If a specific name is found, turn on that button
				if c.name == (charName + "_head_CTL") do window.pickHead.visible = true
				if c.name == (charName + "_neck_CTL") do window.pickNeck.visible = true
				if c.name == (charName + "_lookat_CTL") do window.pickLookat.visible = true
				if c.name == (charName + "_eye_R_CTL") do window.pickREye.visible = true
				if c.name == (charName + "_eye_L_CTL") do window.pickLeye.visible = true
				if c.name == (charName + "_eyes_CTL") do window.pickEyes.visible = true
				if c.name == (charName + "_face_CTL") do window.pickFace.visible = true
				
				if c.name == (charName + "_chest_CTL") do window.pickChest.visible = true
				if c.name == (charName + "_back_CTL") do window.pickBack.visible = true
				if c.name == (charName + "_hip_CTL") do window.pickHip.visible = true
				if c.name == (charName + "_torso_CTL") do window.pickTorso.visible = true
				
				if c.name == (charName + "_R_clavicle_CTL") do window.pickRClav.visible = true
				if c.name == (charName + "_R_shoulder_CTL") do window.pickRShoul.visible = true
				if c.name == (charName + "_R_elbow_CTL") do window.pickRElbow.visible = true
				if c.name == (charName + "_R_elbow_IK_CTL") do window.pickRElbowIK.visible = true
				if c.name == (charName + "_R_hand_IK_CTL") do window.pickRHandIK.visible = true
				if c.name == (charName + "_R_hand_FK_CTL") do window.pickRHandFK.visible = true
				if c.name == (charName + "_R_hand_CTL") do window.pickRHandP.visible = true
				if c.name == (charName + "_R_hand_Rot_CTL") do window.pickRHandR.visible = true
				if c.name == (charName + "_R_fingers_CTL") do window.pickRFingers.visible = true
				/*
				if c.name == (charName + "_R_Finger_Thumb_CTL") do window.pickRThumb.visible = true
				if c.name == (charName + "_R_Finger_Index_CTL") do window.pickRIndex.visible = true 
				if c.name == (charName + "_R_Finger_Middle_CTL") do window.pickRMiddle.visible = true
				if c.name == (charName + "_R_Finger_Ring_CTL") do window.pickRRing.visible = true 
				if c.name == (charName + "_R_Finger_Pinkie_CTL") do window.pickRPinky.visible = true
				*/
				if c.name == (charName + "_L_clavicle_CTL") do window.pickLClav.visible = true 
				if c.name == (charName + "_L_shoulder_CTL") do window.pickLShoul.visible = true
				if c.name == (charName + "_L_elbow_CTL") do window.pickLElbow.visible = true 
				if c.name == (charName + "_L_elbow_IK_CTL") do window.pickLElbowIK.visible = true
				if c.name == (charName + "_L_hand_IK_CTL") do window.pickLHandIK.visible = true 
				if c.name == (charName + "_L_hand_FK_CTL") do window.pickLHandFK.visible = true
				if c.name == (charName + "_L_hand_CTL") do window.pickLHandP.visible = true 
				if c.name == (charName + "_L_hand_Rot_CTL") do window.pickLHandR.visible = true 
				if c.name == (charName + "_L_fingers_CTL") do window.pickLFingers.visible = true 
				/*		
				if c.name == (charName + "_L_Finger_Thumb_CTL") do window.pickLThumb.visible = true
				if c.name == (charName + "_L_Finger_Index_CTL") do window.pickLIndex.visible = true 
				if c.name == (charName + "_L_Finger_Middle_CTL") do window.pickLMiddle.visible = true
				if c.name == (charName + "_L_Finger_Ring_CTL") do window.pickLRing.visible = true 
				if c.name == (charName + "_L_Finger_Pinkie_CTL") do window.pickLPinky.visible = true
				*/
				if c.name == (charName + "_R_hip_CTL") do window.pickRHip.visible = true 
				if c.name == (charName + "_R_knee_CTL") do window.pickRKnee.visible = true 
				if c.name == (charName + "_R_knee_IK_CTL") do window.pickRKneeIK.visible = true
				if c.name == (charName + "_R_foot_IK_CTL") do window.pickRFootIK.visible = true
				if c.name == (charName + "_R_foot_FK_CTL") do window.pickRFootFK.visible = true
				if c.name == (charName + "_R_toe_FK_CTL") do window.pickRBall.visible = true 
				if c.name == (charName + "_R_toes_CTL") do window.pickRToes.visible = true 
				/*
				if c.name == (charName + "_R_Toe_Big_CTL") do window.pickRBig.visible = true
				if c.name == (charName + "_R_Toe_Index_CTL") do window.pickRSecond.visible = true 
				if c.name == (charName + "_R_Toe_Middle_CTL") do window.pickRThird.visible = true
				if c.name == (charName + "_R_Toe_Fourth_CTL") do window.pickRFourth.visible = true 
				if c.name == (charName + "_R_Toe_Little_CTL") do window.pickRLittle.visible = true
				*/
				if c.name == (charName + "_L_hip_CTL") do window.pickLHip.visible = true 
				if c.name == (charName + "_L_knee_CTL") do window.pickLKnee.visible = true 
				if c.name == (charName + "_L_knee_IK_CTL") do window.pickLKneeIK.visible = true
				if c.name == (charName + "_L_foot_IK_CTL") do window.pickLFootIK.visible = true
				if c.name == (charName + "_L_foot_FK_CTL") do window.pickLFootFK.visible = true
				if c.name == (charName + "_L_toe_FK_CTL") do window.pickLBall.visible = true 
				if c.name == (charName + "_L_toes_CTL") do window.pickLToes.visible = true  
				/*
				if c.name == (charName + "_L_Toe_Big_CTL") do window.pickLBig.visible = true
				if c.name == (charName + "_L_Toe_Index_CTL") do window.pickLSecond.visible = true 
				if c.name == (charName + "_L_Toe_Middle_CTL") do window.pickLThird.visible = true
				if c.name == (charName + "_L_Toe_Fourth_CTL") do window.pickLFourth.visible = true 
				if c.name == (charName + "_L_Toe_Little_CTL") do window.pickLLittle.visible = true
				*/
				if c.name == (charName + "_root_CTL") do window.pickRoot.visible = true
			)
		)
		return true
	),

	-----------------------------------------------------------------------------
	-- Finds all characters in the scene by root nodes
	-----------------------------------------------------------------------------
	function listCharacters =
	(
		local characters = #()
		local sceneChars = $'*_root_CTL' 
		
		for o in sceneChars do
		(
			-- strip away _root_CTL
			local charName = substituteString o.name "_root_CTL" "" 
			append characters charName
		)
		
		return characters
	),
	
	-----------------------------------------------------------------------------
	-- Pick a controller by name
	-----------------------------------------------------------------------------
	function pickCTL charName CTLname =
	(
		try
		(
			execute ("select $'" + charName + "_" + CTLname + "_CTL'" )
			return true
		)
		catch
		(
			format ("-- Controller $'" + charName + "_" + CTLname + "_CTL' not found! \n")
			return false
		)
	),

	-----------------------------------------------------------------------------
	-- Add or remove controller to selection list
	-----------------------------------------------------------------------------
	function boolSelCTL charName CTLname =
	(
		if $selection.count > 0 then
		(
			for n = 1 to $selection.count do
			(
				o = $selection[n]
				
				-- If the controller is already selected, we deselect it
				if o.name == (charName + "_" + CTLname + "_CTL") then 
				(
					deselect o
					return true
				-- If the controller isn't selected, we select it
				) else (
					try
					(
						execute ("selectMore $'" + charName + "_" + CTLname + "_CTL'" )
						return true
					)
					catch
					(
						format "-- Controller not found! \n"
						return false
					)
				)
			) -- for n = 1 to $selection
		) else SSR_gui.pickCTL charName CTLname
	),
	
	-----------------------------------------------------------------------------
	-- Sets a dropdown-list to the named string, if it exists
	-----------------------------------------------------------------------------
	--superRigSelector_UI.charDropList SSR_curSelChar
	function setSelection dropList charName = 
	(
		local counter = 1
		if dropList.items.count > 0 then
		(
			for o in dropList.items do
			(
				if o == charName then
					
				(
					dropList.selection = counter
					return true
				)
				counter = counter + 1
			)
		)
		SSR_gen.verbose "Previously selected character not found."
		return false
	),

	-----------------------------------------------------------------------------
	-- Resets attributes on all character controllers
	-- all:true will reset all controllers on the character
	-- static:true will also reset typically static attributes, like soft IK
	-----------------------------------------------------------------------------
	function resetCharAttributes charName all:true static:false =
	(
		-- If the animate button is off, we can ruin our animation
		if animButtonState == false then
		(
			if (queryBox "The animate button is off, resetting can potentially ruin your animation!\n\nAre you sure you want to continue?")==false then return false
		)
		
		-- Store current selection, so we can return to it later
		local storedSelection = $selection as array
		
		if all == true then execute ("select $'" + charName + "*_CTL'" )
		local charControls = $selection as array
			
		for c in charControls do
		(
			if c.modifiers.count >= 1 and (classOf c.modifiers[1] == 'PEN_Attribute_Holder 2') then
			(
				onMod = c.modifiers[1]
				
				caDefs = #()
				caSubs = #()
				
				--Get the Defs
				caNum = (custAttributes.count onMod)
				for x = 1 to caNum do	append caDefs (custAttributes.get onMod x)
				
				--Get the Ca's in the Defs
				for x = 1 to cadefs.count do
				(
					for y = 1 to caDefs[x].numsubs do	append caSubs caDefs[x][y]
				)

				if caSubs.count > 0 do
				(
					for x = 1 to caSubs.count do 
					(
						try(
							-- If the track is without keys and IK type, then we won't reset it
							if static == true and caSubs[x].name == "soft" then ()
							else if static == true and caSubs[x].name == "soft_IK" then ()
							else if static == true and caSubs[x].name == "arm_FK_IK_switch" then ()
							else if static == true and caSubs[x].name == "FK_IK_switch" then ()
							else if caSubs[x].name == "Scale_Rig" then caSubs[x].value = 1.0
							else caSubs[x].value = 0
						)
						catch()
					)
				)
			)
		)
		
		-- Reset our initial selection
		select storedSelection
		return true
	),

	-----------------------------------------------------------------------------
	-- Keys attributes on all character controllers
	-- all:true will reset all controllers on the character
	-- static:true will also reset typically static attributes, like soft IK
	-----------------------------------------------------------------------------
	function keyCharAttributes charName all:true forceAnimButton:true =
	(
		-- If the animate button is off, setting keys can ruin the animation
		if animButtonState == false and forceAnimButton == false then
		(
			if (queryBox "The animate button is off, keying will not work!\n\nAre you sure you know what you are doing?")==false then return false
		)
		
		-- Store current selection, so we can return to it later
		local storedSelection = $selection as array
		local setKeyMode = maxOps.setKeyMode
		local autoKeyMode = animButtonState
		
		-- If forceAnimButton is true, we set the auto key button
		if forceAnimButton == true and animButtonState == false then animButtonState = on
		
		if all == true then execute ("select $'" + charName + "*_CTL'" )
		local charControls = $selection as array
		
		for c in charControls do
		(
			if c.modifiers.count >= 1 and (classOf c.modifiers[1] == 'PEN_Attribute_Holder 2') then
			(
				onMod = c.modifiers[1]
				
				caDefs = #()
				caSubs = #()
				
				--Get the Defs
				caNum = (custAttributes.count onMod)
				for x = 1 to caNum do	append caDefs (custAttributes.get onMod x)
				
				--Get the Ca's in the Defs
				for x = 1 to cadefs.count do
				(
					for y = 1 to caDefs[x].numsubs do	append caSubs caDefs[x][y]
				)

				if caSubs.count > 0 do
				(
					for x = 1 to caSubs.count do 
					(
						try(
							-- If the track is without keys and IK type, then we won't reset it
							if caSubs[x].name == "soft" then ()
							else if caSubs[x].name == "soft_IK" then ()
							else if caSubs[x].name == "arm_FK_IK_switch" then ()
							else caSubs[x].value = caSubs[x].value
						)
						catch()
					)
				)
			)
		)
		
		-- Reset our initial selection
		select storedSelection
		if forceAnimButton == true then 
		(
			maxOps.setKeyMode = setKeyMode
			animButtonState = autoKeyMode
		)
		return true
	),


	-----------------------------------------------------------------------------
	-- SRU_align: 
	--	aligns orientation of first object to second object
	--	(but keeps its original position)
	-----------------------------------------------------------------------------
	function objAlign target source flipZ:false =
	(
		if target == undefined or source == undefined then 
		(
			SSR_gen.verbose ("Missing align object")
			return false
		)
		local tempPos = target.pos
		target.transform = source.transform
		target.pos = tempPos
		
		if flipZ == true then in coordsys target rotate target (angleaxis -180 [0,0,1])
		
		return tempPos
	),

	-----------------------------------------------------------------------------
	-- SRU_keyAll: 
	--	keys all custom attributes in controller
	--	(only works if animate button is on)
	-----------------------------------------------------------------------------
	function keyAll controller =
	(
		caDefs = #()
		caSubs = #()
		
		--Get the Defs
		caNum = (custAttributes.count controller.modifiers[1])
		for x = 1 to caNum do append caDefs (custAttributes.get controller.modifiers[1] x)
		
		--Get the Ca's in the Defs
		for x = 1 to cadefs.count do
		(
			for y = 1 to caDefs[x].numsubs do append caSubs caDefs[x][y]
		)
		if caSubs.count > 0 do
		(
			for x = 1 to caSubs.count do try(caSubs[x].value = caSubs[x].value)catch()
		)
		--SSR_gen.verbose ("Returning " + caSubs.count as string + " attributes.")
		return true
	),

	-----------------------------------------------------------------------------
	-- FK/IK switch. Will do a switch on the selected controller
	-----------------------------------------------------------------------------
	function ikSwitch charName debug:true =
	(
		if $selection.count != 1 then
		(
			SSR_gen.verbose "Select a controller, please."
			return false
		)
		
		local curSel = $selection[1]
		
		-- What limb and side are we working on?
		local limb = subString curSel.name (charName.count+4) 4
		local side = subString curSel.name (charName.count+1) 2
		
		if debug == true then SSR_gen.verbose ("Limb: " + limb + ", Side: " + side)
		
		-- IK to FK Switch for biped bones
		if limb == "foot" then
		(
			local sideText = " "
			if side == "_R" then sideText = " right" else if side == "_L" then sideText = " left"
			SSR_gen.verbose ("Switching from IK to FK on " + charName + sideText + " leg.")
			
			-- Fetch the objects that we need
			local footIKCTL = execute ("$'" + charName + side + "_foot_IK_CTL'")
			local kneeIKCTL = execute ("$'" + charName + side + "_knee_IK_CTL'")
			local hipCTL = execute ("$'" + charName + side + "_hip_CTL'")
			local kneeCTL = execute ("$'" + charName + side + "_knee_CTL'")
			local footCTL = execute ("$'" + charName + side + "_foot_FK_CTL'")
			local toeCTL = execute ("$'" + charName + side + "_toe_FK_CTL'")
			
			local thighBone = execute ("$'" + charName + side + "_leg_IKBone_Thigh'")
			local shinBone = execute ("$'" + charName + side + "_leg_IKBone_Shin'")
			local footBone = execute ("$'" + charName + side + "_leg_skinBone_Foot'")
			local toeBone = execute ("$'" + charName + side + "_leg_IKBone_Toe'")
			
			SSR_gen.verbose ("Pre IK pos: " + footIKCTL.pos as string + ", pre FK pos:" + footCTL.pos as string)
			
			with animate on (
				-- Set keys for everything on previous frame
				sliderTime -= 1
				
				SSR_gui.keyAll footIKCTL
				SSR_gui.keyall kneeIKCTL
				
				SSR_gui.keyAll hipCTL
				SSR_gui.keyAll kneeCTL
				SSR_gui.keyAll footCTL
				SSR_gui.keyAll toeCTL
				
				sliderTime += 1
				
				if footIKCTL.modifiers[1].FKIK.FK_IK_switch < 50.0 then
				(
					SSR_gen.verbose ("FK to IK")
					-- FK to IK: Align up the FK bones and key the IK switch
					-- The left side leg must be flipped after alignment
					local doFlip = false
					if side == "_L" then doFlip = true
					
					SSR_gui.objAlign hipCTL thighBone flipZ:doFLip
					SSR_gui.objAlign kneeCTL shinBone flipZ:doFLip
					SSR_gui.objAlign footCTL footBone flipZ:doFLip
					SSR_gui.objAlign toeCTL toeBone flipZ:doFLip
					
					footIKCTL.modifiers[1].FKIK.FK_IK_switch = 100.0
				) else (
					-- IK to FK: Align up the IK bones and key the IK switch
					footIKCTL.modifiers[1].footControls.footRoll = 0
					footIKCTL.modifiers[1].footControls.ballRoll = 0
					footIKCTL.modifiers[1].footControls.sideRoll = 0
					footIKCTL.modifiers[1].footControls.toeWiggle = 0
					footIKCTL.modifiers[1].footControls.heelTwist = 0
					footIKCTL.modifiers[1].footControls.toeTwist = 0
					
					footIKCTL.pos = footBone.pos
					SSR_gui.objAlign footIKCTL footBone
					
					local ex = "(quatToEuler (in coordsys $'" + charName + side + "_foot_IK_CTL' $'" + charName + side + "_leg_IKBone_Ankle'.rotation)).x"
					if debug == true then SSR_gen.verbose ("Ex: " + ex)
					local footOffset = 90 - ( (execute ex) as float )
					if debug == true then SSR_gen.verbose ("Footoffset: " + footOffset as string)
					
					in coordsys local rotate footIKCTL (angleaxis -90 [1,0,0])
					in coordsys local rotate footIKCTL (angleaxis 90 [0,0,1])
					in coordsys local rotate footIKCTL (angleaxis -footOffset [1,0,0])
					
					local tempHelper = point name:"temp" pos:shinBone.pos
					in coordsys shinBone move tempHelper [0,(distance footBone.pos thighBone.pos),0]
					kneeIKCTL.pos = tempHelper.pos
					delete tempHelper
					
					-- Align toe
					local toeRot = (execute( "(quatToEuler (in coordsys $'" + charName + side + "_leg_IKBone_Toe' $'" + charName + side + "_leg_FKBone_Toe'.rotation)).z" )) as float
					if debug == true then SSR_gen.verbose ("Toe Rotation: " + toeRot as string)
					
					footIKCTL.modifiers[1].footControls.toeWiggle = -toeRot
					
					footIKCTL.modifiers[1].FKIK.FK_IK_switch = 0.0
				)
			) -- with animate on
			
			SSR_gen.verbose ("Post IK pos: " + footIKCTL.pos as string + ", post FK pos:" + footCTL.pos as string)
			
		) -- if limb == "foot"
		
		-- IK to FK Switch for arms
		if limb == "hand" then
		(
			local sideText = " "
			if side == "_R" then sideText = " right" else if side == "_L" then sideText = " left"
			SSR_gen.verbose ("Switching from IK to FK on " + charName + sideText + " arm.")
			
			-- Fetch the objects that we need
			local handIKCTL = execute ("$'" + charName + side + "_hand_IK_CTL'")
			local elbowIKCTL = execute ("$'" + charName + side + "_elbow_IK_CTL'")
			local shoulderCTL = execute ("$'" + charName + side + "_shoulder_CTL'")
			local elbowCTL = execute ("$'" + charName + side + "_elbow_CTL'")
			local handFKCTL = execute ("$'" + charName + side + "_hand_FK_CTL'")
			
			local upArmBone = execute ("$'" + charName + side + "_arm_bone_UpperArm'")
			if upArmBone ==  undefined then upArmBone = execute ("$'" + charName + side + "_arm_skinBone_UpperArm'")
			local lowArmBone = execute ("$'" + charName + side + "_arm_bone_LowerArm'")
			if lowArmBone ==  undefined then lowArmBone = execute ("$'" + charName + side + "_arm_skinBone_LowerArm'")
			local handBone = execute ("$'" + charName + side + "_arm_skinBone_Hand'")
			
			with animate on (
				-- Set keys for everything on previous frame
				sliderTime -= 1
				
				SSR_gui.keyAll handIKCTL
				SSR_gui.keyall elbowIKCTL
				
				SSR_gui.keyAll shoulderCTL
				SSR_gui.keyAll elbowCTL
				SSR_gui.keyAll handFKCTL
				
				sliderTime += 1
				
				if handIKCTL.modifiers[1].FKIK.FK_IK_switch > 50.0 then
				(
					-- Align FK bones and key the IK switch
					-- The left side must be flipped after alignment
					local doFlip = false
					if side == "_L" then doFlip = true
					
					SSR_gui.objAlign shoulderCTL upArmBone flipZ:doFLip
					SSR_gui.objAlign elbowCTL lowArmBone flipZ:doFLip
					
					handIKCTL.modifiers[1].FKIK.FK_IK_switch = 0.0
				) else (
					handIKCTL.pos = handBone.pos
					
					local tempHelper = point name:"temp" pos:lowArmBone.pos
					in coordsys lowArmBone move tempHelper [0,-(distance handBone.pos upArmBone.pos),0]
					elbowIKCTL.pos = tempHelper.pos
					delete tempHelper
					
					handIKCTL.modifiers[1].FKIK.FK_IK_switch = 100.0
				)
			) -- with animate on
		) -- if limb == "hand"
		
		-- IK to FK Switch for animal legs
		if limb == "hoof" then
		(
			local num = subString curSel.name (charName.count+9) 1
			if debug == true then SSR_gen.verbose ("num: " + num)
			local sideText = " right"
			if side == "_L" then sideText = " left"
			SSR_gen.verbose ("Switching from IK to FK on " + charName + sideText + " leg.")
			
			-- Fetch the objects that we need
			local hoofIKCTL = execute ("$'" + charName + side + "_hoof_" + num + "_IK_CTL'")
			local kneeIKCTL = execute ("$'" + charName + side + "_knee_" + num + "_IK_CTL'")
			local hoofCTL = execute ("$'" + charName + side + "_hoof_" + num + "_FK_CTL'")
			local kneeCTL = execute ("$'" + charName + side + "_knee_" + num + "_CTL'")
			local hipCTL = execute ("$'" + charName + side + "_hip_" + num + "_CTL'")
			
			local thighBone = execute ("$'" + charName + side + "_leg_" + num + "_skinBone_Thigh'")
			local shinBone = execute ("$'" + charName + side + "_leg_" + num + "_skinBone_Shin'")
			local hoofBone = execute ("$'" + charName + side + "_leg_" + num + "_skinBone_Foot'")
			
			with animate on (
				-- Set keys for everything on previous frame
				sliderTime -= 1
				
				SSR_gui.keyAll hoofIKCTL
				SSR_gui.keyall kneeIKCTL
				
				SSR_gui.keyAll hoofCTL
				SSR_gui.keyAll kneeCTL
				SSR_gui.keyAll hipCTL
				
				sliderTime += 1
				
				if hoofIKCTL.modifiers[1].FKIK.FK_IK_switch < 50.0 then
				(
					-- Align FK bones and key the IK switch
					-- The left side leg must be flipped after alignment
					local doFlip = false
					if side == "_L" then doFlip = true
					
					SSR_gui.objAlign hipCTL thighBone flipZ:doFLip
					SSR_gui.objAlign kneeCTL shinBone flipZ:doFLip
					SSR_gui.objAlign hoofCTL hoofBone flipZ:doFLip
					
					hoofIKCTL.modifiers[1].FKIK.FK_IK_switch = 100.0
				) else (
					-- Align IK bones and key the IK switch
					hoofIKCTL.modifiers[1].footControls.footRoll = 0
					hoofIKCTL.modifiers[1].footControls.heelTwist = 0
					hoofIKCTL.modifiers[1].footControls.toeTwist = 0
					
					hoofIKCTL.pos = hoofBone.pos
					SSR_gui.objAlign hoofIKCTL hoofBone
					
					local ex = "(quatToEuler (in coordsys $'" + charName + side + "_hoof_" + num + "_IK_CTL' $'" + charName + side + "_leg_" + num + "_IKBone_Foot'.rotation)).x"
					if debug == true then SSR_gen.verbose ("Ex: " + ex)
					local footOffset = 90 - ( (execute ex) as float )
					if debug == true then SSR_gen.verbose ("Footoffset: " + footOffset as string)
					
					in coordsys local rotate hoofIKCTL (angleaxis -90 [1,0,0])
					in coordsys local rotate hoofIKCTL (angleaxis 90 [0,0,1])
					in coordsys local rotate hoofIKCTL (angleaxis -footOffset [1,0,0])
					
					local tempHelper = point name:"temp" pos:shinBone.pos
					in coordsys shinBone move tempHelper [0,(distance hoofBone.pos thighBone.pos),0]
					kneeIKCTL.pos = tempHelper.pos
					delete tempHelper
					
					hoofIKCTL.modifiers[1].FKIK.FK_IK_switch = 0.0
				)
			) -- with animate on 
		) -- if limb == "foot"
		
		return true
	),

	-----------------------------------------------------------------------------
	-- Root Lock. Switches the root lock between the two lock object and world
	-----------------------------------------------------------------------------
	function lockRoot charName index debug:true =
	(
		-- Store the root position
		local rootCTL = execute ("$'" + charName + "_root_CTL'")
		local rootPos = rootCTL.pos
		
		if debug == true then SSR_gen.verbose (rootPos as string)
		
		-- Go back one frame, store the position
		with animate on (
			sliderTime -= 1
			rootCTL.pos = rootCTL.pos
			rootCTL.modifiers[1].locks.lockNum = rootCTL.modifiers[1].locks.lockNum
		
			sliderTime += 1
			--  do the lock, reposition the root
			rootCTL.modifiers[1].locks.lockNum = index
			rootCTL.pos = rootPos
			
		) -- with animate on
		return true
	)

	
	
	
) -- struct SSR_gui

SSR_gui = SSR_gui()